package	jp.co.sds_corp.util.jmx.naming;

import java.util.Hashtable;
import java.util.WeakHashMap;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.spi.ObjectFactory;

import org.jnp.interfaces.NamingContext;
import org.jnp.server.NamingServer;

public class ENCFactory implements ObjectFactory
{
	private static WeakHashMap<ClassLoader,Context> encs = new WeakHashMap<ClassLoader,Context>();
	private static ClassLoader topLoader;

	public static void setTopClassLoader(ClassLoader topLoader) {
		ENCFactory.topLoader = topLoader;
	}
	public static ClassLoader getTopClassLoader() {
		return ENCFactory.topLoader;
	}

	public Object getObjectInstance(Object obj, Name name, Context nameCtx,
									Hashtable environment)
		throws Exception
	{
		synchronized (encs) {
			ClassLoader ctxClassLoader = Thread.currentThread().getContextClassLoader();
			Context compCtx = (Context) encs.get(ctxClassLoader);

			if (compCtx == null) {
				ClassLoader loader = ctxClassLoader;
				while( loader != null && loader != topLoader && compCtx == null ) {
					compCtx = (Context) encs.get(loader);
					loader = loader.getParent();
				}
				if( compCtx == null ) {
					NamingServer srv = new NamingServer();
					compCtx = new NamingContext(environment, null, srv);
					encs.put(ctxClassLoader, compCtx);
				}
			}
			return compCtx;
		}
	}

}
